<div class="guild-header-wrap">
  <div on:click="set({open: !open})" class="guild-header">
    <span class="guild-name">
      <slot />
    </span>
    <span class="down-arrow">
      &#x25BE;
    </span>
  </div>

  {#if open}
  <div class="guild-dropdown"
       transition:slide="{duration:150}">
    <div class="choice"
         on:click="openModal($guild)">
      <span class="choice-name">
        Settings
      </span>
      <span class="choice-icon">
        <SettingsIconSVG />
      </span>
    </div>

    <div class="choice"
         on:click="createChannel($guildId)">
      <span class="choice-name">
        Create Channel
      </span>
      <span class="choice-icon">
        <PlusIconSVG />
      </span>
    </div>

    <div class="choice"
         on:click="changeNickname($guildId, $userId)">
      <span class="choice-name">
        Set Nickname
      </span>
      <span class="choice-icon">
        <PencilIconSVG />
      </span>
    </div>

    <div class="choice"
         on:click="leave($guildId)">
      <span class="choice-name red">
        Leave Guild
      </span>
      <span class="choice-icon">
        <LeaveSVG />
      </span>
    </div>
  </div>
  {/if}
</div>

<script>
  import GuildSettingsModal from "./modals/GuildSettingsModal.svelte";
  import CreateChannelModal from "./modals/CreateChannelModal.svelte";
  import NicknameModal from "./modals/NicknameModal.svelte";
  import slide from "svelte-transitions-slide";
  import RestClient from "../js/RestClient";
  import GuildStore from "../stores/GuildStore";

  export default {
    transitions: {
      slide
    },
    components: {
      SettingsIconSVG: "./icons/SettingsIconSVG.svelte",
      PlusIconSVG: "./icons/PlusIconSVG.svelte",
      LeaveSVG: "./icons/LeaveSVG.svelte",
      PencilIconSVG: "./icons/PencilIconSVG.svelte"
    },
    methods: {
      async leave(id) {
        await RestClient.post(`/guilds/${id}/leave`);
        GuildStore.unslurp({id});
        this.store.set({guildId: null, channelId: null});
      },
      changeNickname(guildId, userId) {
        this.store.set({
          modal: {
            component: NicknameModal,
            options: {
              guildId,
              // we need to get MemberStore to track data on nicknames / usernames
              nickname: "Not implemented",
              userId
            }
          }
        });
      },
      createChannel(channelId) {
        this.set({open: false});
        this.store.set({
          modal: {
            component: CreateChannelModal,
            options: channelId
          }
        });
      },
      openModal(guild) {
        this.set({open: false});
        this.store.set({
          modal: {
            component: GuildSettingsModal,
            options: guild
          }
        });
      }
    }
  };
</script>

<style>
  .guild-header {
    min-height: 1.5em;
    padding: 1em 0.5em;
    border-bottom: solid 1px #2f3336;
    cursor: pointer;
    transition: background-color ease-in-out 0.1s;
    display: flex;
  }

  .guild-header-wrap {
    position: relative;
  }

  .guild-dropdown {
    width: calc(15vw - 0.5em);
    position: absolute;
    top: 100%;
    background: #202224;
    z-index: 1;
    border-radius: 4px;
    box-shadow: 0 2px 3px #11111110;
    border: 1px #151515 solid;
    margin: 0.25em;
  }

  .guild-header:hover {
    background-color: #222;
  }

  .down-arrow {
    float: right;
    color: #b3b3b3;
  }

  .guild-name {
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    line-height: 1.5em;
    flex: 1;
  }

  .choice {
    padding: 0.5em;
    flex-direction: row;
    display: flex;
    cursor: pointer;
  }

  .choice-icon {
    margin-top: 2px;
  }

  .choice:hover {
    background: #101112;
  }

  .choice-name {
    color: #bbb;
    flex-grow: 1;
    flex-shrink: 1;
  }

  .red {
    color: #f04747;
  }
</style>
